Subject: @var annotations with included variable throw exception
Description

Currently all @var annotations which contain whitespaces are regarded as illformed and throw a InvalidPropertyTypeException.
However, it is common - at least for 3rd party code - to write @var annotations that look as follows:

/**
 * @var integer $number
 */
protected $number;

A good example for this are the gedmo doctrine extensions.

Hence I suggest to parse out all variable references in the annotation before deciding on being illformed.

See ReflectionService@1231:

$declaredType = trim(implode(' ', $this->getPropertyTagValues($className, $propertyName, 'var')), ' \\');

instead:

const VARIABLE_NAME_REGEX = '/[a-zA-Z_\x7f-\xff][a-zA-Z0-9_\x7f-\xff]*/';
...
$declaredType = implode(' ', $this->getPropertyTagValues($className, $propertyName, 'var'));
$declaredType = trim(preg_replace(self::VARIABLE_NAME_REGEX, '', $declaredType), ' \\');

Associated revisions
Revision 4395bcba - 2013-04-30 17:22 - Alexander Berl

[BUGFIX] Allow variable name references in @var annotations

This change loosens the strictness of the @var annotation parsing, where
it would throw an exception when the annotation contained the variable
name it referred to.

So this is now possible::
/**

2015-08-04 1/3



 * @var integer $variable
  */

Change-Id: I0c7fbdd637a7e6e215cb0069270640488c55953e
Fixes: #47114
Releases: master

History
#1 - 2013-04-11 10:55 - Adrian Föder

would you say that relates to https://review.typo3.org/#/c/19079/ ?

#2 - 2013-04-12 18:16 - Alexander Berl
- Assigned To set to Alexander Berl

Only loosely, my as #19079 refers to the validation, while this refers to the parsing of classes in the ReflectionService. So it only relates for those cases
where the @var annotation wasn't parsed at all, because else one wouldn't even get to the validation step.

#3 - 2013-04-12 18:30 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19860

#4 - 2013-04-15 12:43 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19860

#5 - 2013-04-24 10:22 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19860

#6 - 2013-04-30 17:22 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19860

#7 - 2013-05-21 13:17 - Robert Lemke
- Category set to Property

#8 - 2013-05-21 13:28 - Robert Lemke
- Target version deleted (2.1)
#9 - 2014-07-11 20:19 - Alexander Berl
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:4395bcba3a3b49abb16388e05c3ba2e176dd8915.
